function [BestScore,BestMatrice]=ETG_solve(V,TC, goals, conf, type)
% V = Model squeleton
% TC = list of cost structures (concordance matrix, impact matrix, cost
% type)
% return (1) the euclidean distance between the expected asymptotic costs
% and the goals and (2) the best transition matrix
dimens=size(V);
dim=dimens(1);
nbrestarts=100*dim;
BestScore=10000;
BestBestMatrice=-V;
BestBestScore=10000;
BestMatrice=V;
BestEntropy=0;
Variables_matrix=V;
Last_variables=[];
flag=0;
orig=zeros(dim,dim);
for i=1:dim; j=dim; while (j>0 && V(i,j)==0) j=j-1; end; if (j>0) Variables_matrix(i,j)=0; Last_variables=[Last_variables j]; end; end;
if (nargin < 5) type=1; end
while (nbrestarts > 0)
    incr=1;
    if (flag == 0)
        orig=Variables_matrix;
        for i=1:dim; for j=1:dim; if (Variables_matrix(i,j)==1) orig(i,j)=floor(2*rand()); end; end; end;
        
        
        orig=RandomTransition(V);
        % orig=V./(sum(V,2)*ones(1,dim));
        target=RandomTransition(Variables_matrix);
        nb_var=sum(Variables_matrix,2);
        % Pour rattraper les lignes qui ne sont pas alatoires
        for i=1:dim; if (nb_var(i) == 0) target(i,:)=V(i,:); end; end;
        
        dir=Variables_matrix-2*orig;

        oldtarget=target;
        flag=1;
%        disp(sprintf('Changement en %d\n',nbrestarts));
    else
        for i=1:dim; for j=1:dim; if (Variables_matrix(i,j)==1) target(i,j)=max(0,oldtarget(i,j)+0.1*(1-2*rand())); end; end; end;
    end;
    if (mod(nbrestarts,1000) == 0) flag=0; end;
    norme=norm(target);
    target=target/norme;
    olddistance=10000;

    current=orig;
  %  disp(current);

    for i=1:dim; current(i,Last_variables(i))=0; end;
    sommes=sum(current,2);
    for i=1:dim; current(i,Last_variables(i))=(1-sommes(i)); end;
    nbit=0;
 %   disp(current);
    while (incr>0.000000001)
        currentdistance=EuclideanScore(current,TC,goals);
%        disp(sprintf('%d %d %.10f %.10f %10f %5f\n',nbrestarts,nbit,incr,currentdistance,olddistance,Entropy(current)));
        if ( (sum(sum(current <= ones(dim,dim))) == dim*dim)  && (sum(sum(current >= zeros(dim,dim))) == dim*dim))
         if ((currentdistance<olddistance)   )
%        disp(current);
          BestMatrice=current;
          BestScore=currentdistance;
          olddistance=currentdistance;
          current=current+incr*(target-orig);
            for i=1:dim; current(i,Last_variables(i))=0; end;
            sommes=sum(current,2);
            for i=1:dim; current(i,Last_variables(i))=(1-sommes(i)); end;
            %disp(current);
         else 
            current=current-2*incr*(target-orig);
            % pour viter les cas o on passe en dessous aprs une
            % itration
            for i=1:dim; for j=1:dim; if (current(i,j)<0) current(i,j)=0; end; end; end;
            incr=incr/10; 
            olddistance=10000;            
            for i=1:dim; current(i,Last_variables(i))=0; end;
            sommes=sum(current,2);
            for i=1:dim; current(i,Last_variables(i))=(1-sommes(i)); end;
         end
        else
            current=current-incr*(target-orig);
            % pour viter les cas o on passe en dessous aprs une
            % itration
            for i=1:dim; for j=1:dim; if (current(i,j)<0) current(i,j)=0; end; end; end;
            incr=incr/10; 
            olddistance=10000;            
            for i=1:dim; current(i,Last_variables(i))=0; end;
            sommes=sum(current,2);
            for i=1:dim; current(i,Last_variables(i))=(1-sommes(i)); end;
        end
        nbit=nbit+1;
        % disp([nbrestarts nbit incr currentdistance BestScore]);
    end
    
%    disp(target);
%    disp(current);
    
%% D�but fonctionnement sans entropie
if ((sum(sum(BestMatrice <= ones(dim,dim))) == dim*dim)  && (sum(sum(BestMatrice >= zeros(dim,dim))) == dim*dim))
    if (type == 0)
        if (BestScore<BestBestScore)
            BestBestMatrice=BestMatrice;
            BestBestScore=BestScore;
        end
        if (BestBestScore<conf)
            %disp('SUPER');
            nbrestarts=0;
        else
            flag=0;
            nbrestarts=nbrestarts-1;
        end;
    else
%% Fin fonctionnement sans entropie

%% Debut Fonctionnement avec entropie
        if ( (BestScore<conf) && (Entropy(BestMatrice) > BestEntropy) )
            %disp('ou là');
            oldtarget=target;
            BestBestMatrice=BestMatrice;
            BestBestScore=BestScore;
            BestEntropy=Entropy(BestMatrice);
            %disp(sprintf('%d %.10f %5f\n',nbrestarts,BestBestScore,BestEntropy));
        end
            if (BestScore<BestBestScore)
                oldtarget=target;
                BestBestMatrice=BestMatrice;
                BestBestScore=BestScore;
                %disp('ici');
           else
                %flag=0;
                %disp('là');
            end;
        
           
        nbrestarts=nbrestarts-1;
%% Fin Fonctionnement avec entropy
    end;
    
else
    %flag=0;
    %disp('ou ou là');
    %disp(current);
    nbrestarts=nbrestarts-1;
end;


%disp(sprintf('%d %7f %7f %7f %7f\n', nbrestarts, currentdistance, BestScore, BestBestScore, BestEntropy));
end
    BestMatrice=BestBestMatrice;
    BestScore=BestBestScore;
return;
end

